Index: content/base/src/nsScriptLoader.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/base/src/nsScriptLoader.cpp,v
retrieving revision 1.104
diff -p -U 8 -r1.104 nsScriptLoader.cpp
--- content/base/src/nsScriptLoader.cpp	11 Apr 2007 20:18:11 -0000	1.104
+++ content/base/src/nsScriptLoader.cpp	14 May 2007 09:21:29 -0000
@@ -64,16 +64,18 @@
 #include "jscntxt.h"
 #include "nsContentUtils.h"
 #include "nsUnicharUtils.h"
 #include "nsAutoPtr.h"
 #include "nsIXPConnect.h"
 #include "nsContentErrors.h"
 #include "nsIParser.h"
 #include "nsThreadUtils.h"
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
 
 //////////////////////////////////////////////////////////////
 //
 //////////////////////////////////////////////////////////////
 
 // If aMaybeCertPrincipal is a cert principal and aNewPrincipal is not the same
 // as aMaybeCertPrincipal, downgrade aMaybeCertPrincipal to a codebase
 // principal.  Return the downgraded principal, or aMaybeCertPrincipal if no
@@ -463,16 +465,23 @@ nsScriptLoader::ProcessScriptElement(nsI
     if (httpChannel) {
       // HTTP content negotation has little value in this context.
       httpChannel->SetRequestHeader(NS_LITERAL_CSTRING("Accept"),
                                     NS_LITERAL_CSTRING("*/*"),
                                     PR_FALSE);
       httpChannel->SetReferrer(mDocument->GetDocumentURI());
     }
 
+    // set the cookie container of the channel to that of the doc's
+    nsCOMPtr<nsICookieCollector> cookieCollector(do_QueryInterface(channel));
+    if (cookieCollector) {
+      nsCOMPtr<nsICookieContainer> container(do_GetInterface(mDocument));
+      cookieCollector->SetCookieContainer(container);
+    }
+
     rv = NS_NewStreamLoader(getter_AddRefs(loader), this);
     NS_ENSURE_SUCCESS(rv, rv);
 
     rv = channel->AsyncOpen(loader, request);
     NS_ENSURE_SUCCESS(rv, rv);
   } else {
     request->mLoading = PR_FALSE;
     request->mIsInline = PR_TRUE;
Index: content/base/src/nsXMLHttpRequest.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/base/src/nsXMLHttpRequest.cpp,v
retrieving revision 1.179
diff -p -U 8 -r1.179 nsXMLHttpRequest.cpp
--- content/base/src/nsXMLHttpRequest.cpp	13 May 2007 16:41:46 -0000	1.179
+++ content/base/src/nsXMLHttpRequest.cpp	14 May 2007 09:21:36 -0000
@@ -77,16 +77,18 @@
 #include "nsDOMJSUtils.h"
 #include "nsCOMArray.h"
 #include "nsDOMClassInfo.h"
 #include "nsIScriptableUConv.h"
 #include "nsCycleCollectionParticipant.h"
 #include "nsIContentPolicy.h"
 #include "nsContentPolicyUtils.h"
 #include "nsContentErrors.h"
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
 
 #define LOAD_STR "load"
 #define ERROR_STR "error"
 #define PROGRESS_STR "progress"
 #define UPLOADPROGRESS_STR "uploadprogress"
 #define READYSTATE_STR "readystatechange"
 
 // CIDs
@@ -1090,16 +1092,25 @@ nsXMLHttpRequest::OpenRequest(const nsAC
   if (NS_FAILED(rv)) return rv;
 
   //mChannel->SetAuthTriedWithPrehost(authp);
 
   nsCOMPtr<nsIHttpChannel> httpChannel(do_QueryInterface(mChannel));
   if (httpChannel) {
     rv = httpChannel->SetRequestMethod(method);
   }
+  if (NS_FAILED(rv)) return rv;
+
+  // set the http request cookie container to that of the parent document
+  nsCOMPtr<nsICookieCollector> cookieCollector(do_QueryInterface(mChannel));
+  if (cookieCollector && doc) {
+    // find the cookie container
+    nsCOMPtr<nsICookieContainer> cookieContainer = do_GetInterface(doc);
+    cookieCollector->SetCookieContainer(cookieContainer);
+  }
 
   ChangeState(XML_HTTP_REQUEST_OPENED);
 
   return rv;
 }
 
 /* void open (in AUTF8String method, in AUTF8String url); */
 NS_IMETHODIMP
Index: content/html/document/src/nsHTMLDocument.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/html/document/src/nsHTMLDocument.cpp,v
retrieving revision 3.720
diff -p -U 8 -r3.720 nsHTMLDocument.cpp
--- content/html/document/src/nsHTMLDocument.cpp	9 May 2007 02:47:58 -0000	3.720
+++ content/html/document/src/nsHTMLDocument.cpp	14 May 2007 09:21:44 -0000
@@ -123,16 +123,19 @@
 #include "nsIDocumentViewer.h"
 #include "nsIWyciwygChannel.h"
 #include "nsIScriptElement.h"
 #include "nsIScriptError.h"
 #include "nsIMutableArray.h"
 #include "nsArrayUtils.h"
 #include "nsIEffectiveTLDService.h"
 
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
+
 #include "nsIPrompt.h"
 //AHMED 12-2
 #include "nsBidiUtils.h"
 
 #include "nsIEditingSession.h"
 #include "nsIEditor.h"
 #include "nsNodeInfoManager.h"
 
@@ -1962,19 +1965,24 @@ nsHTMLDocument::GetCookie(nsAString& aCo
     NodePrincipal()->GetURI(getter_AddRefs(codebaseURI));
 
     if (!codebaseURI) {
       // Document's principal is not a codebase (may be system), so
       // can't set cookies
 
       return NS_OK;
     }
+	
+    // find the cookie container
+    nsCOMPtr<nsICookieCollector> cookieCollector = do_QueryReferent(mDocumentContainer);
+    nsCOMPtr<nsICookieContainer> cookieContainer;
+    cookieCollector->GetCookieContainer(getter_AddRefs(cookieContainer));
 
     nsXPIDLCString cookie;
-    service->GetCookieString(codebaseURI, mChannel, getter_Copies(cookie));
+    service->GetCookieString(cookieContainer, codebaseURI, mChannel, getter_Copies(cookie));
     CopyASCIItoUTF16(cookie, aCookie);
   }
 
   return NS_OK;
 }
 
 NS_IMETHODIMP
 nsHTMLDocument::SetCookie(const nsAString& aCookie)
@@ -1993,18 +2001,23 @@ nsHTMLDocument::SetCookie(const nsAStrin
 
     if (!codebaseURI) {
       // Document's principal is not a codebase (may be system), so
       // can't set cookies
 
       return NS_OK;
     }
 
+	// find the cookie container
+    nsCOMPtr<nsICookieCollector> cookieCollector = do_QueryReferent(mDocumentContainer);
+    nsCOMPtr<nsICookieContainer> cookieContainer;
+    cookieCollector->GetCookieContainer(getter_AddRefs(cookieContainer));
+
     NS_LossyConvertUTF16toASCII cookie(aCookie);
-    service->SetCookieString(codebaseURI, prompt, cookie.get(), mChannel);
+    service->SetCookieString(cookieContainer, codebaseURI, prompt, cookie.get(), mChannel);
   }
 
   return NS_OK;
 }
 
 // XXX TBI: accepting arguments to the open method.
 nsresult
 nsHTMLDocument::OpenCommon(const nsACString& aContentType, PRBool aReplace)
@@ -2101,16 +2114,23 @@ nsHTMLDocument::OpenCommon(const nsACStr
   nsCOMPtr<nsILoadGroup> group = do_QueryReferent(mDocumentLoadGroup);
 
   rv = NS_NewChannel(getter_AddRefs(channel), uri, nsnull, group);
 
   if (NS_FAILED(rv)) {
     return rv;
   }
 
+  nsCOMPtr<nsICookieCollector> cookieCollector(do_QueryInterface(channel));
+  if (cookieCollector) {
+    nsCOMPtr<nsICookieCollector> cookieCollector = do_QueryReferent(mDocumentContainer);
+    nsCOMPtr<nsICookieContainer> cookieContainer;
+    cookieCollector->GetCookieContainer(getter_AddRefs(cookieContainer));
+  }
+
   // Set the caller principal, if any, on the channel so that we'll
   // make sure to use it when we reset.
   rv = channel->SetOwner(callerPrincipal);
   NS_ENSURE_SUCCESS(rv, rv);
 
   // Before we reset the doc notify the globalwindow of the change,
   // but only if we still have a window (i.e. our window object the
   // current inner window in our outer window).
Index: content/xbl/src/nsXBLService.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/xbl/src/nsXBLService.cpp,v
retrieving revision 1.235
diff -p -U 8 -r1.235 nsXBLService.cpp
--- content/xbl/src/nsXBLService.cpp	11 May 2007 13:34:07 -0000	1.235
+++ content/xbl/src/nsXBLService.cpp	14 May 2007 09:21:48 -0000
@@ -70,16 +70,19 @@
 #include "nsXBLPrototypeBinding.h"
 #include "nsIXBLDocumentInfo.h"
 #include "nsCRT.h"
 #include "nsContentUtils.h"
 #include "nsSyncLoadService.h"
 #include "nsIDOM3Node.h"
 #include "nsContentPolicyUtils.h"
 
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
+
 #include "nsIPresShell.h"
 #include "nsIDocumentObserver.h"
 #include "nsFrameManager.h"
 #include "nsStyleContext.h"
 #include "nsIScriptSecurityManager.h"
 #include "nsIScriptError.h"
 
 #ifdef MOZ_XUL
@@ -1126,16 +1129,23 @@ nsXBLService::FetchBindingDocument(nsICo
   rv = NS_NewXBLContentSink(getter_AddRefs(xblSink), doc, aDocumentURI, nsnull);
   NS_ENSURE_SUCCESS(rv, rv);
 
   // Open channel
   nsCOMPtr<nsIChannel> channel;
   rv = NS_NewChannel(getter_AddRefs(channel), aDocumentURI, nsnull, loadGroup);
   NS_ENSURE_SUCCESS(rv, rv);
 
+  // set the cookie container of the channel to that of the doc's
+  nsCOMPtr<nsICookieCollector> cookieCollector(do_QueryInterface(channel));
+  if (cookieCollector) {
+    nsCOMPtr<nsICookieContainer> container(do_GetInterface(aBoundDocument));
+    cookieCollector->SetCookieContainer(container);
+  }
+
   nsCOMPtr<nsIStreamListener> listener;
   rv = doc->StartDocumentLoad("loadAsInteractiveData",
                               channel,
                               loadGroup,
                               nsnull,
                               getter_AddRefs(listener),
                               PR_TRUE,
                               xblSink);
Index: content/xml/document/src/nsXMLContentSink.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/xml/document/src/nsXMLContentSink.cpp,v
retrieving revision 1.413
diff -p -U 8 -r1.413 nsXMLContentSink.cpp
--- content/xml/document/src/nsXMLContentSink.cpp	1 May 2007 22:24:21 -0000	1.413
+++ content/xml/document/src/nsXMLContentSink.cpp	14 May 2007 09:21:51 -0000
@@ -675,18 +675,17 @@ nsXMLContentSink::LoadXSLStyleSheet(nsIU
   mXSLTProcessor->SetTransformObserver(this);
 
   nsCOMPtr<nsILoadGroup> loadGroup = mDocument->GetDocumentLoadGroup();
   if (!loadGroup) {
     mXSLTProcessor = nsnull;
     return NS_ERROR_FAILURE;
   }
 
-  return mXSLTProcessor->LoadStyleSheet(aUrl, loadGroup,
-                                        mDocument->NodePrincipal());
+  return mXSLTProcessor->LoadStyleSheet(aUrl, loadGroup, mDocument);
 }
 
 nsresult
 nsXMLContentSink::ProcessStyleLink(nsIContent* aElement,
                                    const nsSubstring& aHref,
                                    PRBool aAlternate,
                                    const nsSubstring& aTitle,
                                    const nsSubstring& aType,
Index: content/xml/document/src/nsXMLDocument.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/xml/document/src/nsXMLDocument.cpp,v
retrieving revision 1.256
diff -p -U 8 -r1.256 nsXMLDocument.cpp
--- content/xml/document/src/nsXMLDocument.cpp	25 Apr 2007 16:35:28 -0000	1.256
+++ content/xml/document/src/nsXMLDocument.cpp	14 May 2007 09:21:52 -0000
@@ -86,16 +86,18 @@
 #include "nsIWindowWatcher.h"
 #include "nsIAuthPrompt.h"
 #include "nsIScriptGlobalObjectOwner.h"
 #include "nsIJSContextStack.h"
 #include "nsContentCreatorFunctions.h"
 #include "nsIDOMUserDataHandler.h"
 #include "nsEventDispatcher.h"
 #include "nsNodeUtils.h"
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
 
 
 // ==================================================================
 // =
 // ==================================================================
 
 
 nsresult
@@ -194,17 +196,16 @@ nsXMLDocument::~nsXMLDocument()
 NS_IMPL_CYCLE_COLLECTION_CLASS(nsXMLDocument)
 
 NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(nsXMLDocument, nsDocument)
   NS_IMPL_CYCLE_COLLECTION_TRAVERSE_NSCOMPTR(mScriptContext)
 NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END
 
 // QueryInterface implementation for nsXMLDocument
 NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(nsXMLDocument)
-  NS_INTERFACE_MAP_ENTRY(nsIInterfaceRequestor)
   NS_INTERFACE_MAP_ENTRY(nsIChannelEventSink)
   NS_INTERFACE_MAP_ENTRY(nsIDOMXMLDocument)
   NS_INTERFACE_MAP_ENTRY_CONTENT_CLASSINFO(XMLDocument)
 NS_INTERFACE_MAP_END_INHERITING(nsDocument)
 
 
 NS_IMPL_ADDREF_INHERITED(nsXMLDocument, nsDocument)
 NS_IMPL_RELEASE_INHERITED(nsXMLDocument, nsDocument)
@@ -241,38 +242,41 @@ nsXMLDocument::ResetToURI(nsIURI *aURI, 
 }
 
 /////////////////////////////////////////////////////
 // nsIInterfaceRequestor methods:
 //
 NS_IMETHODIMP
 nsXMLDocument::GetInterface(const nsIID& aIID, void** aSink)
 {
-  if (aIID.Equals(NS_GET_IID(nsIAuthPrompt))) {
-    NS_ENSURE_ARG_POINTER(aSink);
-    *aSink = nsnull;
+  NS_ENSURE_ARG_POINTER(aSink);
+  *aSink = nsnull;
+  nsresult rv;
 
-    nsresult rv;
+  if (aIID.Equals(NS_GET_IID(nsIAuthPrompt))) {
     nsCOMPtr<nsIWindowWatcher> ww(do_GetService(NS_WINDOWWATCHER_CONTRACTID, &rv));
     if (NS_FAILED(rv))
       return rv;
 
     nsCOMPtr<nsIAuthPrompt> prompt;
     rv = ww->GetNewAuthPrompter(nsnull, getter_AddRefs(prompt));
     if (NS_FAILED(rv))
       return rv;
 
     nsIAuthPrompt *p = prompt.get();
     NS_ADDREF(p);
     *aSink = p;
     return NS_OK;
   }
 
-
-  return QueryInterface(aIID, aSink);
+  rv = nsDocument::GetInterface(aIID, aSink);
+  if (NS_FAILED(rv))
+    return QueryInterface(aIID, aSink);
+  else
+    return NS_OK;
 }
 
 // nsIChannelEventSink
 NS_IMETHODIMP
 nsXMLDocument::OnChannelRedirect(nsIChannel *aOldChannel,
                                  nsIChannel *aNewChannel,
                                  PRUint32 aFlags)
 {
@@ -481,16 +485,25 @@ nsXMLDocument::Load(const nsAString& aUr
   // nsIRequest::LOAD_BACKGROUND prevents throbber from becoming active,
   // which in turn keeps STOP button from becoming active  
   rv = NS_NewChannel(getter_AddRefs(channel), uri, nsnull, loadGroup, this, 
                      nsIRequest::LOAD_BACKGROUND);
   if (NS_FAILED(rv)) {
     return rv;
   }
 
+  // set the cookie container of the channel to that of the doc's
+  nsCOMPtr<nsICookieCollector> cookieCollector(do_QueryInterface(channel));
+  if (cookieCollector) {
+    nsCOMPtr<nsICookieContainer> cookieContainer;
+    nsCOMPtr<nsICookieCollector> parentCollector = do_QueryReferent(mDocumentContainer);
+    parentCollector->GetCookieContainer(getter_AddRefs(cookieContainer));
+    cookieCollector->SetCookieContainer(cookieContainer);
+  }
+
   // Set a principal for this document
   // XXXbz StartDocumentLoad should handle that.... And we shouldn't be calling
   // StartDocumentLoad until we get an OnStartRequest from this channel!
   nsCOMPtr<nsISupports> channelOwner;
   rv = channel->GetOwner(getter_AddRefs(channelOwner));
 
   // We don't care if GetOwner() succeeded here, if it failed,
   // channelOwner will be null, which is what we want in that case.
Index: content/xml/document/src/nsXMLDocument.h
===================================================================
RCS file: /cvsroot/mozilla/content/xml/document/src/nsXMLDocument.h,v
retrieving revision 1.86
diff -p -U 8 -r1.86 nsXMLDocument.h
--- content/xml/document/src/nsXMLDocument.h	8 Mar 2007 11:17:13 -0000	1.86
+++ content/xml/document/src/nsXMLDocument.h	14 May 2007 09:21:52 -0000
@@ -48,17 +48,16 @@
 #include "nsIHTMLCSSStyleSheet.h"
 
 class nsIParser;
 class nsIDOMNode;
 class nsIURI;
 class nsIChannel;
 
 class nsXMLDocument : public nsDocument,
-                      public nsIInterfaceRequestor,
                       public nsIChannelEventSink
 {
 public:
   nsXMLDocument(const char* aContentType = "application/xml");
   virtual ~nsXMLDocument();
 
   NS_DECL_ISUPPORTS_INHERITED
 
Index: content/xslt/public/nsIDocumentTransformer.h
===================================================================
RCS file: /cvsroot/mozilla/content/xslt/public/nsIDocumentTransformer.h,v
retrieving revision 1.7
diff -p -U 8 -r1.7 nsIDocumentTransformer.h
--- content/xslt/public/nsIDocumentTransformer.h	3 Oct 2006 02:22:22 -0000	1.7
+++ content/xslt/public/nsIDocumentTransformer.h	14 May 2007 09:21:53 -0000
@@ -36,16 +36,17 @@
  * ***** END LICENSE BLOCK ***** */
  
 #ifndef nsIDocumentTransformer_h__
 #define nsIDocumentTransformer_h__
 
 #include "nsISupports.h"
 
 class nsIDOMDocument;
+class nsIDocument;
 class nsIDOMNode;
 class nsILoadGroup;
 class nsIURI;
 class nsIPrincipal;
 class nsString;
 
 #define NS_ITRANSFORMOBSERVER_IID \
 { 0x04b2d17c, 0xe98d, 0x45f5, \
@@ -73,17 +74,17 @@ NS_DEFINE_STATIC_IID_ACCESSOR(nsITransfo
 class nsIDocumentTransformer : public nsISupports
 {
 public: 
 
   NS_DECLARE_STATIC_IID_ACCESSOR(NS_IDOCUMENTTRANSFORMER_IID)
 
   NS_IMETHOD SetTransformObserver(nsITransformObserver* aObserver) = 0;
   NS_IMETHOD LoadStyleSheet(nsIURI* aUri, nsILoadGroup* aLoadGroup,
-                            nsIPrincipal* aCallerPrincipal) = 0;
+                            nsIDocument* aCallerDocument) = 0;
   NS_IMETHOD SetSourceContentModel(nsIDOMNode* aSource) = 0;
   NS_IMETHOD CancelLoads() = 0;
 
   NS_IMETHOD AddXSLTParamNamespace(const nsString& aPrefix,
                                    const nsString& aNamespace) = 0;
   NS_IMETHOD AddXSLTParam(const nsString& aName,
                           const nsString& aNamespace,
                           const nsString& aValue,
Index: content/xslt/src/xslt/txMozillaStylesheetCompiler.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/xslt/src/xslt/txMozillaStylesheetCompiler.cpp,v
retrieving revision 1.48
diff -p -U 8 -r1.48 txMozillaStylesheetCompiler.cpp
--- content/xslt/src/xslt/txMozillaStylesheetCompiler.cpp	30 Jan 2007 21:21:04 -0000	1.48
+++ content/xslt/src/xslt/txMozillaStylesheetCompiler.cpp	14 May 2007 09:21:56 -0000
@@ -64,16 +64,19 @@
 #include "txAtoms.h"
 #include "txLog.h"
 #include "txMozillaXSLTProcessor.h"
 #include "txStylesheetCompiler.h"
 #include "txXMLUtils.h"
 #include "nsAttrName.h"
 #include "nsIScriptError.h"
 
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
+
 static NS_DEFINE_CID(kCParserCID, NS_PARSER_CID);
 
 static void
 getSpec(nsIChannel* aChannel, nsAString& aSpec)
 {
     if (!aChannel) {
         return;
     }
@@ -466,17 +469,17 @@ class txCompileObserver : public txAComp
 public:
     txCompileObserver(txMozillaXSLTProcessor* aProcessor,
                       nsILoadGroup* aLoadGroup);
     virtual ~txCompileObserver();
 
     TX_DECL_ACOMPILEOBSERVER;
 
     nsresult startLoad(nsIURI* aUri, txStylesheetCompiler* aCompiler,
-                       nsIURI* aReferrerURI);
+                       nsIURI* aReferrerURI, nsICookieContainer* aCookieContainer);
 
 protected:
     nsAutoRefCnt mRefCnt;
 
 private:
     nsRefPtr<txMozillaXSLTProcessor> mProcessor;
     nsCOMPtr<nsILoadGroup> mLoadGroup;
 
@@ -529,17 +532,17 @@ txCompileObserver::loadURI(const nsAStri
     nsCOMPtr<nsIURI> referrerUri;
     rv = NS_NewURI(getter_AddRefs(referrerUri), aReferrerUri);
     NS_ENSURE_SUCCESS(rv, rv);
 
     // Do security check.
     rv = CheckLoadURI(uri, referrerUri, nsnull, nsnull);
     NS_ENSURE_SUCCESS(rv, rv);
 
-    return startLoad(uri, aCompiler, referrerUri);
+    return startLoad(uri, aCompiler, referrerUri, nsnull);
 }
 
 void
 txCompileObserver::onDoneCompiling(txStylesheetCompiler* aCompiler,
                                    nsresult aResult,
                                    const PRUnichar *aErrorText,
                                    const PRUnichar *aParam)
 {
@@ -548,17 +551,17 @@ txCompileObserver::onDoneCompiling(txSty
     }
     else {
         mProcessor->reportError(aResult, aErrorText, aParam);
     }
 }
 
 nsresult
 txCompileObserver::startLoad(nsIURI* aUri, txStylesheetCompiler* aCompiler,
-                             nsIURI* aReferrerURI)
+                             nsIURI* aReferrerURI, nsICookieContainer* aCookieContainer)
 {
     nsCOMPtr<nsIChannel> channel;
     nsresult rv = NS_NewChannel(getter_AddRefs(channel), aUri);
     NS_ENSURE_SUCCESS(rv, rv);
 
     channel->SetLoadGroup(mLoadGroup);
 
     channel->SetContentType(NS_LITERAL_CSTRING("text/xml"));
@@ -568,16 +571,20 @@ txCompileObserver::startLoad(nsIURI* aUr
         httpChannel->SetRequestHeader(NS_LITERAL_CSTRING("Accept"),
                                       NS_LITERAL_CSTRING("text/xml,application/xml,application/xhtml+xml,*/*;q=0.1"),
                                       PR_FALSE);
 
         if (aReferrerURI) {
             httpChannel->SetReferrer(aReferrerURI);
         }
     }
+    nsCOMPtr<nsICookieCollector> cookieCollector = do_QueryInterface(channel);
+    if (cookieCollector) {
+        cookieCollector->SetCookieContainer(aCookieContainer);
+    }
 
     nsCOMPtr<nsIParser> parser = do_CreateInstance(kCParserCID, &rv);
     NS_ENSURE_SUCCESS(rv, rv);
 
     nsRefPtr<txStylesheetSink> sink = new txStylesheetSink(aCompiler, parser);
     NS_ENSURE_TRUE(sink, NS_ERROR_OUT_OF_MEMORY);
 
     channel->SetNotificationCallbacks(sink);
@@ -586,40 +593,45 @@ txCompileObserver::startLoad(nsIURI* aUr
     parser->SetContentSink(sink);
     parser->Parse(aUri);
 
     return channel->AsyncOpen(sink, parser);
 }
 
 nsresult
 TX_LoadSheet(nsIURI* aUri, txMozillaXSLTProcessor* aProcessor,
-             nsILoadGroup* aLoadGroup, nsIPrincipal* aCallerPrincipal)
+             nsILoadGroup* aLoadGroup, nsIDocument* aCallerDocument)
 {
     nsCAutoString spec;
     aUri->GetSpec(spec);
     PR_LOG(txLog::xslt, PR_LOG_ALWAYS, ("TX_LoadSheet: %s\n", spec.get()));
 
+    nsCOMPtr<nsIPrincipal> callerPrincipal = aCallerDocument->NodePrincipal();
+
     nsCOMPtr<nsIURI> referrerURI;
-    aCallerPrincipal->GetURI(getter_AddRefs(referrerURI));
+    callerPrincipal->GetURI(getter_AddRefs(referrerURI));
     NS_ASSERTION(referrerURI, "Caller principal must have a URI!");
 
+    nsCOMPtr<nsICookieContainer> cookieContainer;
+    cookieContainer = do_GetInterface(callerPrincipal);
+
     // Pass source document as the context
-    nsresult rv = CheckLoadURI(aUri, referrerURI, aCallerPrincipal,
+    nsresult rv = CheckLoadURI(aUri, referrerURI, callerPrincipal,
                                aProcessor->GetSourceContentModel());
     NS_ENSURE_SUCCESS(rv, rv);
 
     nsRefPtr<txCompileObserver> observer =
         new txCompileObserver(aProcessor, aLoadGroup);
     NS_ENSURE_TRUE(observer, NS_ERROR_OUT_OF_MEMORY);
 
     nsRefPtr<txStylesheetCompiler> compiler =
         new txStylesheetCompiler(NS_ConvertUTF8toUTF16(spec), observer);
     NS_ENSURE_TRUE(compiler, NS_ERROR_OUT_OF_MEMORY);
 
-    return observer->startLoad(aUri, compiler, referrerURI);
+    return observer->startLoad(aUri, compiler, referrerURI, cookieContainer);
 }
 
 /**
  * handling DOM->txStylesheet
  * Observer needs to do synchronous loads.
  */
 static nsresult
 handleNode(nsIDOMNode* aNode, txStylesheetCompiler* aCompiler)
Index: content/xslt/src/xslt/txMozillaXSLTProcessor.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/xslt/src/xslt/txMozillaXSLTProcessor.cpp,v
retrieving revision 1.65
diff -p -U 8 -r1.65 txMozillaXSLTProcessor.cpp
--- content/xslt/src/xslt/txMozillaXSLTProcessor.cpp	22 Dec 2006 17:22:18 -0000	1.65
+++ content/xslt/src/xslt/txMozillaXSLTProcessor.cpp	14 May 2007 09:21:58 -0000
@@ -1017,19 +1017,19 @@ txMozillaXSLTProcessor::GetFlags(PRUint3
 
     *aFlags = mFlags;
 
     return NS_OK;
 }
 
 NS_IMETHODIMP
 txMozillaXSLTProcessor::LoadStyleSheet(nsIURI* aUri, nsILoadGroup* aLoadGroup,
-                                       nsIPrincipal* aCallerPrincipal)
+                                       nsIDocument* aCallerDocument)
 {
-    nsresult rv = TX_LoadSheet(aUri, this, aLoadGroup, aCallerPrincipal);
+    nsresult rv = TX_LoadSheet(aUri, this, aLoadGroup, aCallerDocument);
     if (NS_FAILED(rv) && mObserver) {
         // This is most likely a network or security error, just
         // use the uri as context.
         nsCAutoString spec;
         aUri->GetSpec(spec);
         CopyUTF8toUTF16(spec, mSourceText);
         nsresult status = NS_ERROR_GET_MODULE(rv) == NS_ERROR_MODULE_XSLT ? rv :
                           NS_ERROR_XSLT_NETWORK_ERROR;
Index: content/xslt/src/xslt/txMozillaXSLTProcessor.h
===================================================================
RCS file: /cvsroot/mozilla/content/xslt/src/xslt/txMozillaXSLTProcessor.h,v
retrieving revision 1.26
diff -p -U 8 -r1.26 txMozillaXSLTProcessor.h
--- content/xslt/src/xslt/txMozillaXSLTProcessor.h	23 Apr 2007 14:21:54 -0000	1.26
+++ content/xslt/src/xslt/txMozillaXSLTProcessor.h	14 May 2007 09:21:58 -0000
@@ -95,17 +95,17 @@ public:
     NS_DECL_NSIXSLTPROCESSOROBSOLETE
 
     // nsIXSLTProcessorPrivate interface
     NS_DECL_NSIXSLTPROCESSORPRIVATE
 
     // nsIDocumentTransformer interface
     NS_IMETHOD SetTransformObserver(nsITransformObserver* aObserver);
     NS_IMETHOD LoadStyleSheet(nsIURI* aUri, nsILoadGroup* aLoadGroup,
-                              nsIPrincipal* aCallerPrincipal);
+                              nsIDocument* aCallerDocument);
     NS_IMETHOD SetSourceContentModel(nsIDOMNode* aSource);
     NS_IMETHOD CancelLoads() {return NS_OK;}
     NS_IMETHOD AddXSLTParamNamespace(const nsString& aPrefix,
                                      const nsString& aNamespace);
     NS_IMETHOD AddXSLTParam(const nsString& aName,
                             const nsString& aNamespace,
                             const nsString& aSelect,
                             const nsString& aValue,
@@ -157,15 +157,15 @@ private:
     txNamespaceMap mParamNamespaceMap;
     nsRefPtr<txResultRecycler> mRecycler;
 
     PRUint32 mFlags;
 };
 
 extern nsresult TX_LoadSheet(nsIURI* aUri, txMozillaXSLTProcessor* aProcessor,
                              nsILoadGroup* aLoadGroup,
-                             nsIPrincipal* aCallerPrincipal);
+                             nsIDocument* aCallerDocument);
 
 extern nsresult TX_CompileStylesheet(nsIDOMNode* aNode,
                                      txMozillaXSLTProcessor* aProcessor,
                                      txStylesheet** aStylesheet);
 
 #endif
